function [omega_hat_inv_mat]=omega_hat_inv_cos_depnull(xmat,w,qvec);
% Compute omega_hat using orthogonal series weights
% x is T x m
% w is T x qmax matrix of weights
% qvec is vector of q values
%
m = size(xmat,2);
nb = size(xmat,3);
nq = size(qvec,1);

omega_hat_inv_mat = NaN(m,m,nq,nb);
for ib = 1:nb;
  x = squeeze(xmat(:,:,ib));
  xdm = x - mean(x);  % just to be sure .. weights should be orthogonal to 1 anyway
  y = w'*xdm;
  omega_hat_mat = NaN(m,m,nq);
  for i = 1:nq;
     q = qvec(i);
     omega_hat_mat(:,:,i) = y(1:q,:)'*y(1:q,:)/q;
  end; 
  if m == 1
    omega_hat_inv_mat(:,:,:,ib) = 1./omega_hat_mat;
  end
  if m > 1
    for in = 1:nq;
     omega_hat_inv_mat(:,:,in,ib) = inv(squeeze(omega_hat_mat(:,:,in)));
    end;
  end
end;


end